#include<talkthrough.h>
#include <fract.h>
#include <filter.h>

int OldSigma_L_4=0, OldDelta_L_1=0, OldDelta_L_2=0, OldDelta_L_3=0,Sigma_L_1=0,
Sigma_L_2=0,OldSigma_L_5=0,OldDelta_L_4=0,Result1=0,Sigma_L_4=0,Sigma_L_3=0,Delta_L_1=0,
Delta_L_2=0,Delta_L_3=0,Sigma_L_5=0,Delta_L_4=0,OldSigma_L_3=0;

int OldSigma_R_4=0, OldDelta_R_1=0, OldDelta_R_2=0, OldDelta_R_3=0,Sigma_R_1=0,
Sigma_R_2=0,OldSigma_R_5=0,OldDelta_R_4=0,Result2=0,Sigma_R_4=0,Sigma_R_3=0,Delta_R_1=0,
Delta_R_2=0,Delta_R_3=0,Sigma_R_5=0,Delta_R_4=0,OldSigma_R_3=0;

fract16 input1[Size];

fract16 input2[Size];

int GetBit(int *,int,int);

section ("sdram0") fract16 out_fir_A[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_A1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_A2[Size + NUM_TAPS2 - 1];


section ("sdram0") fract16 out_fir_B[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_B1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_B2[Size + NUM_TAPS2 - 1];


section ("sdram0") fract16 out_fir_C[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_C1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_C2[Size + NUM_TAPS2 - 1];


section ("sdram0") fract16 out_fir_D[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_D1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_D2[Size + NUM_TAPS2 - 1];


section ("sdram0") fract16 out_fir_E[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_E1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_E2[Size + NUM_TAPS2 - 1];


section ("sdram0") fract16 out_fir_F[Size + NUM_TAPS4 - 1];

section ("sdram0") fract16 out_fir_F1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_F2[Size + NUM_TAPS2 - 1];


extern int process_index;
extern int Buf_Index;

#define I2S_MODE

#define SELEN 0x0f


extern fir_state_fr16 state1_Left;

extern fir_state_fr16 state2_Left;

extern fir_state_fr16 state3_Left;

extern fir_state_fr16 state4_Left;

extern fir_state_fr16 state1_Right;

extern fir_state_fr16 state2_Right;

extern fir_state_fr16 state3_Right;

extern fir_state_fr16 state4_Right;


extern void Process_Data(void);

//---5th order CIC to reconstruct the PDM data----//

void filter( int *buff)

{
int i,j,l;



	for(j=0;j<Size;j++)
{  
	OldSigma_L_5 = Sigma_L_5;          
	OldDelta_L_1 = Delta_L_1;         
	OldDelta_L_2 = Delta_L_2;           
	OldDelta_L_3 = Delta_L_3;          
	OldDelta_L_4 = Delta_L_4;
	
	OldSigma_R_5 = Sigma_R_5;          
	OldDelta_R_1 = Delta_R_1;         
	OldDelta_R_2 = Delta_R_2;           
	OldDelta_R_3 = Delta_R_3;          
	OldDelta_R_4 = Delta_R_4;
	
	
	for(i =0; i<16; i=i+2)    
		
			{
						   Sigma_L_1 += GetBit(buff,j,i);  // to extract each bit   
						   Sigma_L_2 += Sigma_L_1;         
						   Sigma_L_3 += Sigma_L_2;         
						   Sigma_L_4 += Sigma_L_3;         
						   Sigma_L_5 += Sigma_L_4;  
						        
			}
					//Delta of L
						Delta_L_1 = Sigma_L_5 - OldSigma_L_5; 
						Delta_L_2 = Delta_L_1 - OldDelta_L_1; 
						Delta_L_3 = Delta_L_2 - OldDelta_L_2; 
						Delta_L_4 = Delta_L_3 - OldDelta_L_3; 
						Result1   = Delta_L_4 - OldDelta_L_4; 
			

	input1[j] = Result1;

	
	
		for(i =1; i<16; i=i+2)    
		
			{
						   Sigma_R_1 += GetBit(buff,j,i);  // to extract each bit   
						   Sigma_R_2 += Sigma_R_1;         
						   Sigma_R_3 += Sigma_R_2;         
						   Sigma_R_4 += Sigma_R_3;         
						   Sigma_R_5 += Sigma_R_4;  
						        
			}
					//Delta of L
						Delta_R_1 = Sigma_R_5 - OldSigma_R_5; 
						Delta_R_2 = Delta_R_1 - OldDelta_R_1; 
						Delta_R_3 = Delta_R_2 - OldDelta_R_2; 
						Delta_R_4 = Delta_R_3 - OldDelta_R_3; 
						Result2   = Delta_R_4 - OldDelta_R_4; 
		
						
							
			input2[j] = Result2; 
			
			
			
			
}
	
	
	
	if(Buf_Index==0)
	{


            fir_decima_fr16(input1, out_fir_A1, Size, &state1_Left);
		    
	        fir_decima_fr16(out_fir_A1, out_fir_A2, Size/2, &state2_Left);
	        
       //  fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_A2, out_fir_A, Size/4, &state4_Left);
	        
	        
	        
	        fir_decima_fr16(input2, out_fir_B1, Size, &state1_Right);
		    
	        fir_decima_fr16(out_fir_B1, out_fir_B2, Size/2, &state2_Right);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_B2, out_fir_B, Size/4, &state4_Right);


process_index=1;
	}
	
	else if(Buf_Index==1)
			{
            fir_decima_fr16(input1, out_fir_C1, Size, &state1_Left);
		    
	        fir_decima_fr16(out_fir_C1, out_fir_C2, Size/2, &state2_Left);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_C2, out_fir_C, Size/4, &state4_Left);
	        
	        
	        
	        fir_decima_fr16(input2, out_fir_D1, Size, &state1_Right);
		    
	        fir_decima_fr16(out_fir_D1, out_fir_D2, Size/2, &state2_Right);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_D2, out_fir_D, Size/4, &state4_Right);

process_index=2;

	}
	
	else if(Buf_Index==2)
	{
            fir_decima_fr16(input1, out_fir_E1, Size, &state1_Left);
		    
	        fir_decima_fr16(out_fir_E1, out_fir_E2, Size/2, &state2_Left);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_E2, out_fir_E, Size/4, &state4_Left);
	        
	        
	        
	        fir_decima_fr16(input2, out_fir_F1, Size, &state1_Right);
		    
	        fir_decima_fr16(out_fir_F1, out_fir_F2, Size/2, &state2_Right);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_F2, out_fir_F, Size/4, &state4_Right);

process_index=3;
	}
	
}

int GetBit(int *buffer,int word, int bit)
{ 
	int current_word = buffer[word];
	int current_bit;
	
	current_word>>= bit;
	current_bit = current_word & 0x1;
	
	return current_bit;
	
	
}